/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Launchy
 *
 * The Initial Developer of the Original Code is Henrik Gemal.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Henrik Gemal <launchy@gemal.dk> http://gemal.dk
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gLaunchyExeIE = false;
var gLaunchyExeOpera = false;
var gLaunchyExeNetscape = false;
var gLaunchyExeFirebird = false;
var gLaunchyExeMozilla = false;
var gLaunchyExeKMeleon = false;
var gLaunchyExeBSPlayer = false;
var gLaunchyExeMediaPlayer = false;
var gLaunchyExeThunderbird = false;
var gLaunchyExeOutlookExpress = false;
var gLaunchyExeOutlook = false;

// Put everything into a namespace so that we dont pollute
var LaunchyContext = function() {
	launchyShared.trace("LaunchyContext");

	try {
		include(jslib_fileutils);
	} catch(ex) {
		launchyShared.trace("JSLib isn't installed");
		alert("JSLib isn't installed: " + ex);
		return;
	}
	launchyShared.trace("JSLib version " + JS_LIB_VERSION + " installed");

	var fu=new FileUtils();
	var winhooks = Components.classes["@mozilla.org/winhooks;1"].getService(Components.interfaces.nsIWindowsRegistry);

	// Find Internet Explorer
	try {
		gLaunchyExeIE = winhooks.getRegistryEntry(3, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\IEXPLORE.EXE", "");
	} catch(ex) {
		launchyShared.trace("Unable to find Internet Explorer: " + ex);
	}
	if (gLaunchyExeIE && fu.exists(gLaunchyExeIE)) {
		launchyShared.trace("Internet Explorer is installed at: <" + gLaunchyExeIE + ">");
	} else {
		launchyShared.trace("Internet Explorer isn't installed or undetected");
	}

	// Find Mozilla
	try {
		var gLaunchyExeMozilla_version = winhooks.getRegistryEntry(3, "Software\\mozilla.org\\Mozilla", "CurrentVersion");
		if (gLaunchyExeMozilla_version) {
			gLaunchyExeMozilla = winhooks.getRegistryEntry(3, "Software\\mozilla.org\\Mozilla\\" + gLaunchyExeMozilla_version + "\\Main", "PathToExe");
		}
	} catch(ex) {
		launchyShared.trace("Unable to find Mozilla: " + ex);
	}
	if (gLaunchyExeMozilla && fu.exists(gLaunchyExeMozilla)) {
		launchyShared.trace("Mozilla is installed at: <" + gLaunchyExeMozilla + ">");
	} else {
		launchyShared.trace("Mozilla isn't installed or undetected");
	}

	// Find Opera
	try {
		gLaunchyExeOpera = winhooks.getRegistryEntry(3, "Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\Opera.exe", "");
	} catch(ex) {
		launchyShared.trace("Unable to find Opera: " + ex);
	}
	if (gLaunchyExeOpera && fu.exists(gLaunchyExeOpera)) {
		launchyShared.trace("Opera is installed at: <" + gLaunchyExeOpera + ">");
	} else {
		launchyShared.trace("Opera isn't installed or undetected");
	}

	// Find Mozilla Firebird
	try {
		var gLaunchyExeFirebird_version = winhooks.getRegistryEntry(3, "Software\\mozilla.org\\Mozilla Firebird", "CurrentVersion");
		if (gLaunchyExeFirebird_version) {
			gLaunchyExeFirebird = winhooks.getRegistryEntry(3, "Software\\mozilla.org\\Mozilla Firebird\\" + gLaunchyExeFirebird_version + "\\Main", "PathToExe");
		}
	} catch(ex) {
		launchyShared.trace("Unable to find Mozilla Firebird: " + ex);
	}
	if (gLaunchyExeFirebird && fu.exists(gLaunchyExeFirebird)) {
		launchyShared.trace("Mozilla Firebird is installed at: <" + gLaunchyExeFirebird + ">");
	} else {
		launchyShared.trace("Mozilla Firebird isn't installed or undetected");
	}

	// Find Netscape
	try {
		var gLaunchyExeNetscape_version = winhooks.getRegistryEntry(3, "Software\\Netscape\\Netscape", "CurrentVersion");
		if (gLaunchyExeNetscape_version) {
			gLaunchyExeNetscape = winhooks.getRegistryEntry(3, "Software\\Netscape\\Netscape\\" + gLaunchyExeNetscape_version + "\\Main", "PathToExe");
		}
	} catch(ex) {
		launchyShared.trace("Unable to find Netscape: " + ex);
	}
	if (gLaunchyExeNetscape && fu.exists(gLaunchyExeNetscape)) {
		launchyShared.trace("Netscape is installed at: <" + gLaunchyExeNetscape + ">");
	} else {
		launchyShared.trace("Netscape isn't installed or undetected");
	}

	// Find K-Meleon
	try {
		gLaunchyExeKMeleon = winhooks.getRegistryEntry(2, "Software\\K-Meleon\\K-Meleon\\General", "InstallDir");
		if (gLaunchyExeKMeleon) {
			gLaunchyExeKMeleon += "\\k-meleon.exe";
		}
	} catch(ex) {
		launchyShared.trace("Unable to find K-Meleon: " + ex);
	}
	if (gLaunchyExeKMeleon && fu.exists(gLaunchyExeKMeleon)) {
		launchyShared.trace("K-Meleon is installed at: <" + gLaunchyExeKMeleon + ">");
	} else {
		launchyShared.trace("K-Meleon isn't installed or undetected");
	}

	// Find BSPlayer
	try {
		gLaunchyExeBSPlayer = winhooks.getRegistryEntry(2, "Software\\BST\\bsplayerv1", "AppPath");
	} catch(ex) {
		launchyShared.trace("Unable to find BSPlayer: " + ex);
	}
	if (gLaunchyExeBSPlayer && fu.exists(gLaunchyExeBSPlayer)) {
		launchyShared.trace("BSPlayer is installed at: <" + gLaunchyExeBSPlayer + ">");
	} else {
		launchyShared.trace("BSPlayer isn't installed or undetected");
	}

	// Find Windows Media Player
	try {
		gLaunchyExeMediaPlayer = winhooks.getRegistryEntry(3, "Software\\Microsoft\\MediaPlayer", "Installation Directory");
		if (gLaunchyExeMediaPlayer) {
			gLaunchyExeMediaPlayer += "\\wmplayer.exe";
		}
	} catch(ex) {
		launchyShared.trace("Unable to find Windows Media Player: " + ex);
	}
	if (gLaunchyExeMediaPlayer && fu.exists(gLaunchyExeMediaPlayer)) {
		launchyShared.trace("Windows Media Player is installed at: <" + gLaunchyExeMediaPlayer + ">");
	} else {
		launchyShared.trace("Windows Media Player isn't installed or undetected");
	}

	// Find Outlook Express
	try {
		gLaunchyExeOutlookExpress = winhooks.getRegistryEntry(3, "Software\\Microsoft\\WAB\\Export\\CSV", "DLL");
		if (gLaunchyExeOutlookExpress) {
			launchyShared.trace("Outlook Express CSV entry found: <" + gLaunchyExeOutlookExpress + ">");
			var re=/wabimp\.dll/;
			gLaunchyExeOutlookExpress = gLaunchyExeOutlookExpress.replace(re, "msimn.exe");
			launchyShared.trace("Outlook Express CSV entry converted: <" + gLaunchyExeOutlookExpress + ">");
		}
	} catch(ex) {
		launchyShared.trace("Unable to find Outlook Express: " + ex);
	}
	if (gLaunchyExeOutlookExpress && fu.exists(gLaunchyExeOutlookExpress)) {
		launchyShared.trace("Outlook Express is installed at: <" + gLaunchyExeOutlookExpress + ">");
	} else {
		launchyShared.trace("Outlook Express isn't installed or undetected");
	}

	// Find Outlook
	try {
		gLaunchyExeOutlook = winhooks.getRegistryEntry(3, "Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\OUTLOOK.EXE", "");
	} catch(ex) {
		launchyShared.trace("Unable to find Outlook: " + ex);
	}
	if (gLaunchyExeOutlook && fu.exists(gLaunchyExeOutlook)) {
		launchyShared.trace("Outlook is installed at: <" + gLaunchyExeOutlook + ">");
	} else {
		launchyShared.trace("Outlook isn't installed or undetected");
	}

	// Find Mozilla Thunderbird
	try {
		var gLaunchyExeThunderbird_version = winhooks.getRegistryEntry(3, "Software\\mozilla.org\\Mozilla Thunderbird", "CurrentVersion");
		if (gLaunchyExeThunderbird_version) {
			gLaunchyExeThunderbird = winhooks.getRegistryEntry(3, "Software\\mozilla.org\\Mozilla Thunderbird\\" + gLaunchyExeThunderbird_version + "\\Main", "PathToExe");
		}
	} catch(ex) {
		launchyShared.trace("Unable to find Mozilla Thunderbird: " + ex);
	}
	if (gLaunchyExeThunderbird && fu.exists(gLaunchyExeThunderbird)) {
		launchyShared.trace("Mozilla Thunderbird is installed at: <" + gLaunchyExeThunderbird + ">");
	} else {
		launchyShared.trace("Mozilla Thunderbird isn't installed or undetected");
	}
}

LaunchyContext.prototype.doContext = function() {
	launchyShared.trace("doContext");
	var onlink = false;

	var ele = new Array("launchy-context-ie", "launchy-context-opera", "launchy-context-netscape", "launchy-context-firebird", "launchy-context-mozilla", "launchy-context-kmeleon");
	var eleLink = new Array("launchy-context-ie-link", "launchy-context-opera-link", "launchy-context-netscape-link", "launchy-context-firebird-link", "launchy-context-mozilla-link", "launchy-context-kmeleon-link");
	var eleMedia = new Array("launchy-context-bsplayer", "launchy-context-mediaplayer");
	var eleMediaLink = new Array("launchy-context-bsplayer-link", "launchy-context-mediaplayer-link");
	var eleMail = new Array("launchy-context-mozillamail", "launchy-context-thunderbird", "launchy-context-outlookexpress", "launchy-context-outlook");

	try {
		if (gContextMenu.onMailtoLink) {
			launchyShared.trace("onMailtoLink")
			for (var i=0; i < eleMail.length; i++) {
				document.getElementById(eleMail[i]).setAttribute("hidden", false);
			}
			for (var i=0; i < ele.length; i++) {
				document.getElementById(ele[i]).setAttribute("hidden", true);
			}
			for (var i=0; i < eleLink.length; i++) {
				document.getElementById(eleLink[i]).setAttribute("hidden", true);
			}
			for (var i=0; i < eleMedia.length; i++) {
				document.getElementById(eleMedia[i]).setAttribute("hidden", true);
			}
			for (var i=0; i < eleMediaLink.length; i++) {
				document.getElementById(eleMediaLink[i]).setAttribute("hidden", true);
			}
			document.getElementById("launchy-context-mail").setAttribute("hidden", true);
			document.getElementById("launchy-context-media").setAttribute("hidden", true);
		} else if (gContextMenu.onLink) {
			launchyShared.trace("onLink")
			for (var i=0; i < ele.length; i++) {
				document.getElementById(ele[i]).setAttribute("hidden", true);
			}
			for (var i=0; i < eleLink.length; i++) {
				document.getElementById(eleLink[i]).setAttribute("hidden", false);
			}
			for (var i=0; i < eleMedia.length; i++) {
				document.getElementById(eleMedia[i]).setAttribute("hidden", true);
			}
			for (var i=0; i < eleMediaLink.length; i++) {
				document.getElementById(eleMediaLink[i]).setAttribute("hidden", false);
			}
			for (var i=0; i < eleMail.length; i++) {
				document.getElementById(eleMail[i]).setAttribute("hidden", true);
			}
			document.getElementById("launchy-context-mail").setAttribute("hidden", true);
			document.getElementById("launchy-context-media").setAttribute("hidden", false);
			onlink = true;
		} else {
			launchyShared.trace("Not onLink")
			for (var i=0; i < ele.length; i++) {
				document.getElementById(ele[i]).setAttribute("hidden", false);
			}
			for (var i=0; i < eleLink.length; i++) {
				document.getElementById(eleLink[i]).setAttribute("hidden", true);
			}
			for (var i=0; i < eleMedia.length; i++) {
				document.getElementById(eleMedia[i]).setAttribute("hidden", true);
			}
			for (var i=0; i < eleMediaLink.length; i++) {
				document.getElementById(eleMediaLink[i]).setAttribute("hidden", true);
			}
			for (var i=0; i < eleMail.length; i++) {
				document.getElementById(eleMail[i]).setAttribute("hidden", true);
			}
			document.getElementById("launchy-context-media").setAttribute("hidden", true);
			document.getElementById("launchy-context-mail").setAttribute("hidden", true);
		}
		if (!gLaunchyExeIE) {
			document.getElementById("launchy-context-ie").setAttribute("hidden", true);
			document.getElementById("launchy-context-ie-link").setAttribute("hidden", true);
		}
		if (!gLaunchyExeOpera) {
			document.getElementById("launchy-context-opera").setAttribute("hidden", true);
			document.getElementById("launchy-context-opera-link").setAttribute("hidden", true);
		}
		if (!gLaunchyExeNetscape) {
			document.getElementById("launchy-context-netscape").setAttribute("hidden", true);
			document.getElementById("launchy-context-netscape-link").setAttribute("hidden", true);
		}
		if (!gLaunchyExeFirebird) {
			document.getElementById("launchy-context-firebird").setAttribute("hidden", true);
			document.getElementById("launchy-context-firebird-link").setAttribute("hidden", true);
		}
		if (!gLaunchyExeMozilla) {
			document.getElementById("launchy-context-mozilla").setAttribute("hidden", true);
			document.getElementById("launchy-context-mozilla-link").setAttribute("hidden", true);
			document.getElementById("launchy-context-mozillamail").setAttribute("hidden", true);
		}
		if (!gLaunchyExeKMeleon) {
			document.getElementById("launchy-context-kmeleon").setAttribute("hidden", true);
			document.getElementById("launchy-context-kmeleon-link").setAttribute("hidden", true);
		}
		if (!gLaunchyExeBSPlayer) {
			document.getElementById("launchy-context-bsplayer").setAttribute("hidden", true);
			document.getElementById("launchy-context-bsplayer-link").setAttribute("hidden", true);
		}
		if (!gLaunchyExeMediaPlayer) {
			document.getElementById("launchy-context-mediaplayer").setAttribute("hidden", true);
			document.getElementById("launchy-context-mediaplayer-link").setAttribute("hidden", true);
		}
		if (!gLaunchyExeOutlookExpress) {
			document.getElementById("launchy-context-outlookexpress").setAttribute("hidden", true);
		}
		if (!gLaunchyExeOutlook) {
			document.getElementById("launchy-context-outlook").setAttribute("hidden", true);
		}
		if (!gLaunchyExeThunderbird) {
			document.getElementById("launchy-context-thunderbird").setAttribute("hidden", true);
		}
	} catch(ex) {
		launchyShared.trace(ex);
	}
	return;
}

// Opens an URL in an external program
// t is the type of program:
// 1: Internet Explorer
// 2: Mozilla
// 3: Mozilla Firebird
// 4: Opera
// 5: Netscape
// 6: K-Meleon
// 100: BSPlayer
// 101: Windows Media Player
// 200: Mozilla Mail
// 201: Mozilla Thunderbird
// 202: Outlook Express
// 203: Outlook
LaunchyContext.prototype.doOpen = function(t, l) {
	launchyShared.trace("doOpen");
	// do we have an URL or should we just use the current one?
	var url;
	if (l) {
		url = gContextMenu.link;
	} else {
		url = document.commandDispatcher.focusedWindow.document.location.href;
	}

	var exe;
	switch (t) {
		case 1:
			exe = gLaunchyExeIE;
			break;
		case 2:
			exe = gLaunchyExeMozilla;
			break;
		case 3:
			exe = gLaunchyExeFirebird;
			break;
		case 4:
			exe = gLaunchyExeOpera;
			break;
		case 5:
			exe = gLaunchyExeNetscape;
			break;
		case 6:
			exe = gLaunchyExeKMeleon;
			break;
		case 100:
			exe = gLaunchyExeBSPlayer;
			break;
		case 101:
			exe = gLaunchyExeMediaPlayer;
			break;
		case 200:
			exe = gLaunchyExeMozilla;
			break;
		case 201:
			exe = gLaunchyExeThunderbird;
			url = "-compose " + url;
			break;
		case 202:
			exe = gLaunchyExeOutlookExpress;
			url = "/mailurl:" + url;
			break;
		case 203:
			exe = gLaunchyExeOutlook;
			url = "-c IPM.Note /m " + url;
			break;
		default:
			launchyShared.trace("Unknown switch: " + t);
			break;
	}
	if (exe) {
		try {
			launchyShared.trace("about to run:\n<" + exe + "> <" + url + ">");
			var fu=new FileUtils();
			fu.run(exe, [url]);
		} catch(ex) {
			launchyShared.trace("Unable to run:\n<" + exe + "> <" + url + ">\ndue to " + ex);
		}
	} else {
		launchyShared.trace("not found: " + t);
	}
}

LaunchyContext.prototype.help = function() {
	launchyShared.trace("help");
	document.commandDispatcher.focusedWindow.document.location.href = "http://gemal.dk/mozilla/launchy.html?ver=1.0.0";
}

// create the object
const launchyContext = new LaunchyContext();
